unit kuFontDialog;
{
 2018.1
  .     .
:  
kuzduk@mail.ru
kuzduk.000webhostapp.com

        

  :
Ctrl +  
Ctrl + +
Ctrl + -

Shift +      
}

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Spin, XPStyleActnCtrls,
  ActnList, ActnMan, ActnPopup, ExtCtrls, StdCtrls, ImgList, StdStyleActnCtrls,
  Menus, Dialogs, ComCtrls, Buttons, IniFiles,

  kuLanguageUni,
  kuY,
  kuModul;

type
  TFormFont = class(TForm)

    fColor: TBitBtn;
    fBold: TCheckBox;
    fItalic: TCheckBox;
    fUnderline: TCheckBox;
    fStrike: TCheckBox;
    fSize: TSpinEdit;
    fName: TComboBox;
    fExample: TRichEdit;
    ImageList1: TImageList;
    ColorDialog1: TColorDialog;
    ActionManager1: TActionManager;
    Act_Bold: TAction;
    Act_Italic: TAction;
    Act_Underline: TAction;
    Act_Strike: TAction;
    Act_Color: TAction;
    Act_SizeUp: TAction;
    Act_SizeDn: TAction;
    Act_OK: TAction;
    Act_Cancel: TAction;
    pmFont: TPopupActionBar;
    pmBold: TMenuItem;
    pmItalic: TMenuItem;
    pmUnderline: TMenuItem;
    pmStrike: TMenuItem;
    N4: TMenuItem;
    pmSizeUp: TMenuItem;
    pmSizeDown: TMenuItem;
    N5: TMenuItem;
    pmColor: TMenuItem;
    N6: TMenuItem;
    pmOK: TMenuItem;
    pmClose: TMenuItem;
    btnOK: TButton;
    btnCancel: TButton;

    procedure fSizeChange(Sender: TObject);
    procedure fNameChange(Sender: TObject);
    procedure Act_CancelExecute(Sender: TObject);
    procedure Act_OKExecute(Sender: TObject);
    procedure Act_BoldExecute(Sender: TObject);
    procedure Act_ItalicExecute(Sender: TObject);
    procedure Act_UnderlineExecute(Sender: TObject);
    procedure Act_StrikeExecute(Sender: TObject);
    procedure Act_ColorExecute(Sender: TObject);
    procedure Act_SizeUpExecute(Sender: TObject);
    procedure Act_SizeDnExecute(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormResize(Sender: TObject);
    procedure fColorMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);

    private
      fResult: Boolean;

  end;

var
  FormFont: TFormFont;

  __FormCaption  : string = 'Font';
//  __Name      : string = 'Name';
//  __Size      : string = 'Size';
  __SizeUp    : string = 'Size Up';
  __SizeDn    : string = 'Size Down';
  __Color     : string = 'Color';
  __ExampleHint : string = 'Example of font';
  __Example     : string = 'ABCDEFGHIJKLMN' +#13#10+ 'Ũ' +#13#10+ '012345+_=\@*';
//  __Style     : string = 'Style';
  __Bold      : string = 'Bold';
  __Italic    : string = 'Italic';
  __Underline : string = 'Underline';
  __Strike    : string = 'Strike';
  __OK        : string = 'OK';
  __Cancel    : string = 'Cancel';


  function kuFontDialogExecute(FontInOut: TFont; HideParam: string = ''): Boolean;



implementation

{$R *.dfm}



//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Font Dialog
function kuFontDialogExecute(FontInOut: TFont; HideParam: string = ''): Boolean;
{
FontInOut -     .

      :
n - Name
z - Size
c - Color
b - Bold
i - Italic
u - Underline
s - Strike
}
var
  b: Boolean;
  i: integer;


begin with FormFont do begin

if Application.FindComponent('FormFont') = nil then Application.CreateForm(TFormFont, FormFont);

fResult := False;
Result := False;



{$REGION ' Lng '}

FormFont.Caption       := __FormCaption;
Act_SizeUp.Caption     := __SizeUp;
Act_SizeDn.Caption     := __SizeDn;
Act_Color.Caption      := __Color;
Act_Bold.Caption       := __Bold;
Act_Italic.Caption     := __Italic;
Act_Underline.Caption  := __Underline;
Act_Strike.Caption     := __Strike;

fExample.Lines.Text   := __Example;

Act_OK.Caption         := __OK;
Act_Cancel.Caption      := __Cancel;


//Hint
fSize.Hint          := __SizeUp +'  ('+ ShortCutToText(Act_SizeUp.ShortCut) +')'+#10#13+ __SizeDn +'  (' + ShortCutToText(Act_SizeDn.ShortCut) +')' ;
Act_Color.Hint      := __Color;
Act_Bold.Hint       := __Bold;
Act_Italic.Hint     := __Italic;
Act_Underline.Hint  := __Underline;
Act_Strike.Hint     := __Strike;

fExample.Hint       := __ExampleHint;

Act_OK.Hint         := __OK;
Act_Cancel.Hint     := __Cancel;


{$ENDREGION}




{$REGION ' nzcbius '}


b := (Pos('n', HideParam) = 0);
fName.Enabled := b;
fName.Visible := b;


b := (Pos('z', HideParam) = 0);
fSize.Enabled := b;
fSize.Visible := b;
Act_SizeUp.Enabled := b;
Act_SizeUp.Visible := b;
Act_SizeDn.Enabled := b;
Act_SizeDn.Visible := b;


b := (Pos('c', HideParam) = 0);
fColor.Enabled := b;
fColor.Visible := b;
Act_Color.Enabled := b;
Act_Color.Visible := b;


b := (Pos('b', HideParam) = 0);
Act_Bold.Enabled := b;
Act_Bold.Visible := b;


b := (Pos('i', HideParam) = 0);
Act_Italic.Enabled := b;
Act_Italic.Visible := b;


b := (Pos('u', HideParam) = 0);
Act_Underline.Enabled := b;
Act_Underline.Visible := b;


b := (Pos('s', HideParam) = 0);
Act_Strike.Enabled := b;
Act_Strike.Visible := b;


{$ENDREGION}





fColor.Caption := '';
fName.Items := Screen.Fonts;


if FontInOut = nil

then
begin
ShowMessage('FontInOut = nil!!!');
exit;
//    Memo1.Font.Style := Memo1.Font.Style - [fsBold] - [fsItalic] - [fsUnderline] - [fsStrikeOut];
//    Memo1.Font.Color := $0;
//    Memo1.Font.Size  := 12;
//
//    fName.Text := Memo1.Font.Name;
//    fSize.Value  := Memo1.Font.Size;
//    fColor.Font.Color := Memo1.Font.Color;
//
//    Act_Bold.Checked       := False;
//    Act_Italic.Checked     := False;
//    Act_Underline.Checked  := False;
//    Act_Strike.Checked     := False;
end

else
begin
    // 
    fExample.Font.Assign(FontInOut);
    fExample.Text := __Example;


    fName.Text := FontInOut.Name;
    i := fName.Items.IndexOf(FontInOut.Name);
    if i <> -1 then fName.ItemIndex := i;
    fSize.Value  := FontInOut.Size;

    fColor.Font.Color := FontInOut.Color;
    FormFont.Resize;


    if (FontInOut.Style = FontInOut.Style + [fsBold])
    then Act_Bold.Checked := True
    else Act_Bold.Checked := False;

    if (FontInOut.Style = FontInOut.Style + [fsItalic])
    then Act_Italic.Checked := True
    else Act_Italic.Checked := False;

    if (FontInOut.Style = FontInOut.Style + [fsUnderline])
    then Act_Underline.Checked := True
    else Act_Underline.Checked := False;

    if (FontInOut.Style = FontInOut.Style + [fsStrikeOut])
    then Act_Strike.Checked := True
    else Act_Strike.Checked := False;
end;


FormFont.ShowModal;



{  . . .  }



if fResult then FontInOut.Assign(fExample.Font);

Result := fResult;


end;end;




{$REGION '   Form   '}




//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Create
procedure TFormFont.FormCreate(Sender: TObject);
var
ini : TIniFile;

begin

if not FileExists(_Lng_Path)
then
begin
    ini := TiniFile.Create( Path_App + _setini );
    __Example := ini.ReadString  ( 'Settings', 'kuFontDialog_Example', __Example );
    __Example := StringReplace(__Example, _Lng_RedLineDelimiter, AZ, [rfReplaceAll]) ;
    ini.Free;
end;


end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Close
procedure TFormFont.FormClose(Sender: TObject; var Action: TCloseAction);
var
strs: TStringList;
ini : TIniFile;
s: string;


begin

if not fExample.Modified then exit;

__Example := fExample.Text;

if FileExists(_Lng_Path)

then
begin
//    yy('lng');
    strs            := TStringList.Create;
    strs.Text       := ANSItoUTF8(strs.Text);
    strs.WriteBOM   := True;
    strs.LoadFromFile(_Lng_Path);

    Strs_AddNameValue('kuFontDialog_Example', Strs_ToStr(fExample.Lines, _Lng_RedLineDelimiter), 'Language', strs, False);

    strs.SaveToFile(_Lng_Path);
    strs.Free;
end

else
begin
//    yy('ini');
    ini := TiniFile.Create( Path_App + _setini );

    ini.WriteString  ( 'Settings', 'kuFontDialog_Example',   Strs_ToStr(fExample.Lines, _Lng_RedLineDelimiter)   );

    ini.Free;
end;

end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Mouse Wheel
procedure TFormFont.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  State : TKeyboardState;
  CtrlDownly, {AltDownly, }ShiftDownly: Boolean;
  i: integer;

begin

Handled := true;

GetKeyboardState(State);
CtrlDownly  := ( (State[VK_CONTROL] and 128) <> 0 );
ShiftDownly := ( (State[VK_SHIFT] and 128) <> 0 );
//AltDownly   := ( (State[VK_MENU] and 128) <> 0 );



if CtrlDownly or ShiftDownly
then
begin

if CtrlDownly
then
begin
    if WheelDelta > 0
    then Act_SizeUp.Execute
    else Act_SizeDn.Execute
end;



if ShiftDownly
then
begin

  if WheelDelta > 0

  then
  begin
    if fName.ItemIndex > 0
    then
    begin

//      if ShiftDownly
//
//      then
//      begin
//          i := fName.ItemIndex - 5;
//          if i < 0 then i := 0;
//          fName.ItemIndex := i;
//      end
//
//      else
      fName.ItemIndex := fName.ItemIndex - 1;

    end;

  end

  else
  begin
    if fName.ItemIndex <> fName.Items.Count - 1
    then
    begin

//      if ShiftDownly
//
//      then
//      begin
//          i := fName.ItemIndex + 5;
//          if i > fName.Items.Count - 1 then i := fName.Items.Count - 1;
//          fName.ItemIndex := i;
//      end
//
//      else
      fName.ItemIndex := fName.ItemIndex + 1;

    end;

  end;

  fName.OnChange(fName);
  fName.SetFocus;

end;

  formfont.SetFocus;
   exit;

end

else
begin
//  yy('fSize focused');

  if fSize.Focused
  then
  begin
      if WheelDelta > 0
      then Act_SizeUp.Execute
      else Act_SizeDn.Execute;
      exit;
  end;
end;


Handled := false;
inherited;


end;



{$ENDREGION}





{$REGION '       '}




//------------------------------------------------------------------------------ Name
procedure TFormFont.fNameChange(Sender: TObject);
begin
fExample.Font.Name := fName.Text;
fExample.Font := fExample.Font;
fExample.Repaint;
end;




{$REGION ' Color '}


//------------------------------------------------------------------------------ Color
procedure TFormFont.Act_ColorExecute(Sender: TObject);
begin
ColorDialog1.Color := fExample.Font.Color;
ColorDialog1.Execute;
fExample.Font.Color := ColorDialog1.Color;
fColor.Font.Color   := ColorDialog1.Color;

FormFont.Resize;
end;



//------------------------------------------------------------------------------ Color Default
procedure TFormFont.fColorMouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
begin

case Button
of
    mbMiddle://        
    begin
      fExample.Font.Color := $0;
      FormFont.Resize;
    end;
end;


end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Resize (for fColor paint)
procedure TFormFont.FormResize(Sender: TObject);
begin
   btnColorDrawRect(fColor, fExample.Font.Color);
end;



{$ENDREGION}





{$REGION ' Size '}


//------------------------------------------------------------------------------ Size
procedure TFormFont.fSizeChange(Sender: TObject);
begin

if fSize.Text = '' then exit;

fExample.Font.Size := fSize.Value;

end;




//------------------------------------------------------------------------------ Size +1
procedure TFormFont.Act_SizeUpExecute(Sender: TObject);
begin
fSize.Value := fSize.Value + 1;
end;



//------------------------------------------------------------------------------ Size -1
procedure TFormFont.Act_SizeDnExecute(Sender: TObject);
begin
fSize.Value := fSize.Value - 1;
end;



{$ENDREGION}





{$REGION '  '}
  

  
//------------------------------------------------------------------------------ Bold
procedure TFormFont.Act_BoldExecute(Sender: TObject);
begin

if fBold.Checked
then fExample.Font.Style := fExample.Font.Style + [fsBold]
else fExample.Font.Style := fExample.Font.Style - [fsBold] ;

end;
  
  
  
//------------------------------------------------------------------------------ Italic
procedure TFormFont.Act_ItalicExecute(Sender: TObject);
begin

if fItalic.Checked
then fExample.Font.Style := fExample.Font.Style + [fsItalic]
else fExample.Font.Style := fExample.Font.Style - [fsItalic]
    
end;
  
  
  
//------------------------------------------------------------------------------ Strike
procedure TFormFont.Act_StrikeExecute(Sender: TObject);
begin

if fStrike.Checked
then fExample.Font.Style := fExample.Font.Style + [fsStrikeOut]
else fExample.Font.Style := fExample.Font.Style - [fsStrikeOut]
    
end;
    
  
  
//------------------------------------------------------------------------------ Underline
procedure TFormFont.Act_UnderlineExecute(Sender: TObject);
begin

if fUnderline.Checked
then fExample.Font.Style := fExample.Font.Style + [fsUnderline]
else fExample.Font.Style := fExample.Font.Style - [fsUnderline]

end;
  
  
  


{$ENDREGION}



  
{$ENDREGION}







//------------------------------------------------------------------------------ OK
procedure TFormFont.Act_OKExecute(Sender: TObject);
begin

fResult := True;
FormFont.Close;

end;




//------------------------------------------------------------------------------ Close
procedure TFormFont.Act_CancelExecute(Sender: TObject);
begin

fResult := False;
FormFont.Close;

end;








end.
