unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IniFiles,

  kuTray, StdCtrls, Menus;

type
  TForm1 = class(TkuForm)

    cb_IconOnRestore: TComboBox;
    pmTray: TPopupMenu;
    N11: TMenuItem;
    N21: TMenuItem;

    procedure cb_IconOnRestoreChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Show
procedure TForm1.FormShow(Sender: TObject);
begin

if not _FirstStart then exit;

_FirstStart := False;

_IconIn := IntToIconIn(cb_IconOnRestore.ItemIndex);

ShowIconIn(_IconIn);

end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Close
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var ini : TIniFile;

begin

ini := TiniFile.Create( ExtractFilePath(Application.ExeName) + 'settings.ini' );

try
//  ini.Writebool     ( 'Settings', 'RunMinimizedToTray', ch_RunMinimizedToTray.Checked  );
//  ini.Writebool     ( 'Settings', 'CloseTotray',        ch_CloseToTray.Checked         );
  ini.WriteInteger  ( 'Settings', 'IconIn',             IconInToInt                    );
finally
  ini.Free;
end;

ShowIconIn(inNone);

end;






//------------------------------------------------------------------------------ OnRestore Icon
procedure TForm1.cb_IconOnRestoreChange(Sender: TObject);
begin

_IconIn := IntToIconIn(Form1.cb_IconOnRestore.ItemIndex);
ShowIconIn(_IconIn);
SetForegroundWindow(Self.Handle);

end;



end.
